<template>
  <div>
    <h1 class="text-2xl text-purple-600">{{ title }}</h1>

    <div class="flex flex-col">
      <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
        <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
          <div
            class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
          >
            <table class="min-w-full divide-y divide-gray-200">
              <thead class="bg-gray-50">
                <tr>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Nombre
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Dirección completa
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Comuna
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Horario
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Empleados designados
                  </th>
                </tr>
                <tr v-for="location in locations" v-bind:key="location.id">
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ location.name }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ location.address1 }} {{ location.address2 }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ location.commune }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ location.startTime }} | {{ location.endTime }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ getUsersByLocation(location.id) }}
                  </th>
                </tr>
              </thead>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      title: 'Sucursales',
      users: [],
      locations: [],
    };
  },
  beforeMount() {
    this.getUsers();
    this.getLocations();
  },
  methods: {
    async getUsers() {
      const res = await fetch('http://localhost:3004/users');
      const data = await res.json();
      this.users = [...data];
    },
    async getLocations() {
      const res = await fetch('http://localhost:3004/locations');
      const data = await res.json();
      this.locations = [...data];
    },
    getUsersByLocation(locationId) {
      const users = [];
      this.users.filter((user) => {
        if (user.locationId[0] === locationId) {
          const name = `${user.firstName} ${user.lastName}`;
          users.push(name);
        }
      });
      return users;
    },
  },
};
</script>
